module Tansu
  module Configuration
    def self.extended(klass)
      klass.instance_variable_set(:"@vars", {})
    end

    def set(name, val)
      self[name]= val
    end

    def get(name)
      self[name]
    end

    def []=(name, val)
      @vars[name] = val
    end

    def [](name)
      @vars[name]
    end

    %i(development test production).each do |env|
      define_method("#{env}?") { self[:environment] == env }
    end

    def configure(&block)
      instance_eval &block
    end
  end
end
