module Tansu
  class Context < Minicontext::Context
    METHODS = %w(GET HEAD POST PATCH PUT DELETE)
    KEYWORD = Minicontext::Context::KEYWORD + METHODS

    def get(name, &block)
      context(name) { task 'GET', &block }
      head(name, &block)
    end

    (METHODS - ['GET']).each do |method|
      define_method(method.downcase.to_sym) do |name, &block|
        context(name) { task method, &block }
      end
    end

    def call(name)
      (val = super(name)) ? val : super(:*)
    end
  end
end
